import { ExecutableResolverOperationNode } from './execution.js';
import { ResolverOperationNode } from './query-planning.js';
export interface SerializedResolverOperationNode {
    id?: number;
    subgraph: string;
    resolverOperationDocument: string;
    resolverDependencies?: SerializedResolverOperationNode[];
    resolverDependencyFieldMap?: Record<string, SerializedResolverOperationNode[]>;
    resolverPreDependencies?: SerializedResolverOperationNode[];
    batch?: boolean;
    defer?: boolean;
}
export declare function serializeResolverOperationNode(resolverOperationNode: ResolverOperationNode & {
    id?: number;
}): SerializedResolverOperationNode;
export declare function deserializeResolverOperationNode(serializedResolverOperationNode: SerializedResolverOperationNode): ResolverOperationNode;
export declare function deserializeResolverOperationNodeExecutable(serializedNode: SerializedResolverOperationNode): ExecutableResolverOperationNode;
export declare function serializeExecutableResolverOperationNode(executableResolverOperationNode: ExecutableResolverOperationNode): SerializedResolverOperationNode;
